// drawablegeom.h

// Copyright (C) 1997  Cliff Johnson                                       //
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public                    //
// License as published by the Free Software Foundation; either            //
// version 2 of the License, or (at your option) any later version.        //
//                                                                         //
// This software is distributed in the hope that it will be useful,        //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU General Public License       //
// along with this software (see COPYING); if not, write to the        //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //

#ifndef _DRAWABELGEOM_H_
#define _DRAWABELGEOM_H_

//#include <bool.h> //ITO
#include <geom.h>
#include <handle.h>

class DrawableGeom 
{
private:
  int type;

public:

  DrawableGeom(int t){ type = t; }

  int Type() const { return type; }

  virtual ~DrawableGeom() {}  // necessary because some containters hold derived classes using
		      // pointers to this base class

  virtual void Draw(const Geom*, const float& scale) const {}; // draw this geom using these attributes
  virtual void Select(const Geom*, const Handle&, const float& scale) const {}; // just like drawing but for selections.
};

#endif
