// tabledrawables.h

// Copyright (C) 1998  Cliff Johnson                                       //
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public                    //
// License as published by the Free Software Foundation; either            //
// version 2 of the License, or (at your option) any later version.        //
//                                                                         //
// This software is distributed in the hope that it will be useful,        //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU General Public License       //
// along with this software (see COPYING); if not, write to the        //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//



 
//  This is a table of drawables - it does two things: 1) it is where the 
//  drawable objects are actually instansiated and where the sacred pointers are
//  kept and 2) it maps each drawable to a int (enum), which can be used in save/recall
//  as well as at viewer registration to get the pointers.

#ifndef TABLEDRAWABLES_H
#define TABLEDRAWABLES_H

#include <map>
#include <drawablegeom.h>

class DrawableException;

class TableDrawables
{

public:

TableDrawables();
~TableDrawables();

const DrawableGeom* Drawable(const int&) const throw (DrawableException);

private:

	map<int, const DrawableGeom*, less<int> > drawableMap;
};

#endif
