// typemaskbehavior.cpp


// Copyright (C) 1997  Cliff Johnson                                       //
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public                    //
// License as published by the Free Software Foundation; either            //
// version 2 of the License, or (at your option) any later version.        //
//                                                                         //
// This software is distributed in the hope that it will be useful,        //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU General Public License       //
// along with this software (see COPYING.LIB); if not, write to the        //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //

//#include <bool.h>
#include <vdapp_enum.h>
#include <geom_enum.h>
#include <typemaskbehavior.h>

TypeMaskBehavior::TypeMaskBehavior()
{

#include <cmdarray.cpp_>
#include <valuearray.cpp_>
	
        for(int i=0;i<NUMBUTTONS;i++)statusArray[i]=false;
        sumMode = false;
}

void TypeMaskBehavior::Clear(vCmdWindow* cmdwindow)
{
	for(int i=0; i<NUMBUTTONS; i++)if(statusArray[i]){
		cmdwindow->SetValue(cmdArray[i],0,Value);
		statusArray[i]=false;
	}
}

void TypeMaskBehavior::All(vCmdWindow* cmdwindow)
{
	for(int i=0; i<NUMBUTTONS; i++)if(!statusArray[i]){
		cmdwindow->SetValue(cmdArray[i],1,Value);
		statusArray[i]=true;
	}
}

void TypeMaskBehavior::SetSumMode(vCmdWindow* cmdwindow,int mode)
{
	if(mode)sumMode=true ;
	else sumMode = false;

// make sure the button shows the correct value
	cmdwindow->SetValue(m_Sum,sumMode,Value);
}

void TypeMaskBehavior::Selected(vCmdWindow* cmdwindow,int id,bool usevaluemask )
{
	int key;

	if(!sumMode)Clear(cmdwindow);

	for(int i=0;i<NUMBUTTONS;i++){

		key = cmdArray[i];	             // copy the key from the command array
		if(usevaluemask)key = valueArray[i]; // or maybe from the vaule array	

		if(key == id){
			if(statusArray[i])statusArray[i]=false;	//negate the value of the status array
			else statusArray[i] = true;
		}
		cmdwindow->SetValue(cmdArray[i],statusArray[i],Value);
	}
}

void TypeMaskBehavior::SetFilter(vCmdWindow* w, const SelectionFilter& sf)
{
	Clear(w);

	SetSumMode(w,true);
	for(int i=0; i < sf.Size() ; i++)Selected(w,sf[i],true); // set according to value mask-
								 // entity values from geom_enum.h
								 // these are the currency of the
								 // SelectionFilter
	SetSumMode(w,false);
}
	
SelectionFilter TypeMaskBehavior::GetFilter() const
{
	SelectionFilter sf;

	for(int i=0; i< NUMBUTTONS; i++){
		
		if(statusArray[i]){
			sf.Add(valueArray[i]);
		}
	}

	return sf;
}
